/*
 * Copyright (C) 2021 Anton Romanov - All Rights Reserved
 * You may use, distribute and modify this code, please write to: romanov73@gmail.com.
 *
 */

package ru.ulstu.service;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;
import ru.ulstu.datamodel.ModelingResult;
import ru.ulstu.datamodel.exception.ModelingException;
import ru.ulstu.datamodel.ts.TimeSeries;

import java.lang.reflect.InvocationTargetException;
import java.util.concurrent.ExecutionException;


@Service
public class TimeSeriesService {
    private static final Logger LOGGER = LoggerFactory.getLogger(TimeSeriesService.class);
    private final MethodParamBruteForce methodParamBruteForce;

    public TimeSeriesService(MethodParamBruteForce methodParamBruteForce) {
        this.methodParamBruteForce = methodParamBruteForce;
    }

    public ModelingResult getForecast(TimeSeries timeSeries, int countPoints) throws ExecutionException, InterruptedException, InvocationTargetException, NoSuchMethodException, InstantiationException, IllegalAccessException, ModelingException {
        return methodParamBruteForce.getForecast(timeSeries, countPoints);
    }

    public TimeSeries smoothTimeSeries(TimeSeries timeSeries) throws ExecutionException, InterruptedException, InvocationTargetException, NoSuchMethodException, InstantiationException, IllegalAccessException {
        return methodParamBruteForce.getSmoothedTimeSeries(timeSeries).getTimeSeries();
    }
}
